<!--文件上传组件-->
<template>
  <div>
    <el-divider content-position="left"><i class="el-icon-document"></i> 附件</el-divider>
    <el-upload ref="upload" style="display: inline-block; :show-header='status'" action=""
               :limit="999" :http-request="httpRequest"
               multiple
               :on-exceed="(files, fileList) =>{
                      $message.warning(`当前限制选择 999 个文件，本次选择了 ${files.length} 个文件，共选择了 ${files.length + fileList.length} 个文件`)
                     }"
               :show-file-list="false"
               :on-change="changes"
               :on-progress="uploadVideoProcess"
               :file-list="fileList">
      <el-button type="info" size="mini" :disabled="auth==='view'">点击上传</el-button>
    </el-upload>
    <div style="height: calc(100% - 80px);margin-top: 10px">
      <!-- 进度条 -->
      <el-progress style="margin-left: 5em" v-if="progressFlag" :percentage="loadProgress"></el-progress>
      <el-table
        ref="uploadTable"
        :key="tableKey"
        :data="dataListNew">
        <el-table-column type="seq" width="40"></el-table-column>
        <el-table-column label="文件名称" prop="name" align="center">
          <template scope="scope">
            <div v-if="ifName(scope.row) === true">
              <el-image
                style="width: 30px; height: 30px;padding-top: 4px"
                :src="scope.row.lsUrl"
                :preview-src-list="[scope.row.lsUrl]"
              ></el-image>
            </div>
            <div v-else>
              <el-link  type="primary" :underline="false" @click="showFile(scope.row)">{{scope.row.name}}</el-link>
            </div>
          </template>
        </el-table-column>
        <el-table-column label="创建人" prop="createBy.name" align="center"></el-table-column>
        <el-table-column label="创建时间" prop="createDate" align="center"></el-table-column>
        <el-table-column label="操作" width="200px" fixed="right" align="center">
          <template  scope="scope">
            <el-button type="text"  icon="el-icon-edit" size="small" @click="toHref(scope.row)" :disabled="false">下载</el-button>
            <el-button type="text"  icon="el-icon-delete" size="small"  @click="deleteById(scope.row, scope.$index)" :disabled="auth==='view'">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <el-image-viewer v-if="showViewer" :on-close="closeViewer" :url-list="[url]" :zIndex=9999></el-image-viewer>
  </div>
</template>

<script>
  // eslint-disable-next-line no-unused-vars
  import OSSSerivce, {
    httpRequest,
    // eslint-disable-next-line no-unused-vars
    handleRemove,
    fileName,
    // eslint-disable-next-line no-unused-vars
    beforeAvatarUpload,
    // eslint-disable-next-line no-unused-vars
    openWindowOnUrl,
    // eslint-disable-next-line no-unused-vars
    toHref
  } from '@/api/sys/OSSService'
  import ElImageViewer from 'element-ui/packages/image/src/image-viewer'
  import moment from 'moment'
  export default {
    data () {
      return {
        progressFlag: false,
        loadProgress: 0,
        fileList: [],
        dataList: [],
        dataListNew: [],
        url: '',
        showViewer: false,
        ossService: null,
        auth: '',
        directory: 'public',
        maxValue: 300,
        tableKey: ''
      }
    },
    watch: {
    },
    created () {
      this.ossService = new OSSSerivce()
    },
    components: {
      ElImageViewer
    },
    mounted () {
      window.onPreview = this.onPreview
    },
    methods: {
      /**
       * 文件上传组件初始化
       * @param auth
       *    auth的值为"view"时,不可上传/编辑文件
       *    auth为其他值时,可上传/编辑文件
       * @param fileList  要显示到文件上传列表中的文件。
       *    注：文件必须要有url属性并且文件的url属性值必须是在oss中的路径值
       *    例：'/attachment-file/xxx/xxx/2022/9/08/xxx.jpg'
       * @param directory  要存放到oss的哪个文件夹下。
       *    注：值为空时，默认存放到"public"文件夹
       * @param maxValue  上传文件允许的最大值，单位：MB
       *    注：值为空时，默认值为300MB
       */
      async newUpload (auth, fileList, directory, maxValue) {
        if (directory !== undefined && directory !== null && directory !== '' && directory !== {}) {
          this.directory = directory
        } else {
          this.directory = 'public'
        }
        if (maxValue !== undefined && maxValue !== null && maxValue !== '' && maxValue !== 0) {
          this.maxValue = maxValue
        } else {
          this.maxValue = 300
        }
        this.auth = auth
        console.log(this.loading)
        for await (let item of fileList) {
          await this.ossService.getTemporaryUrl(item.url).then((data) => {
            item.lsUrl = data.data
            this.dataList.push(item)
            this.dataListNew.push(item)
          })
        }
        // this.dataList = JSON.parse(JSON.stringify(fileList))
        // this.dataListNew = JSON.parse(JSON.stringify(fileList))
      },
      async httpRequest (file) {
        await httpRequest(file, fileName(file), this.directory, this.maxValue)
      },
      uploadVideoProcess (event, file, fileList) {
        this.progressFlag = true // 显示进度条
        this.loadProgress = parseInt(event.percent) // 动态获取文件上传进度
        if (this.loadProgress >= 100) {
          this.loadProgress = 100
          setTimeout(() => { this.progressFlag = false }, 1000) // 一秒后关闭进度条
        }
      },
      async changes (file, fileList) {
        // if (file.status !== 'ready') {
        //   return
        // }
        if (!beforeAvatarUpload(file, fileList, this.maxValue)) {
          this.$message.error('文件大小不能超过 ' + this.maxValue + ' MB!')
          return
        }
        this.dataListNew = []
        this.dataList.forEach((item) => {
          this.dataListNew.push(item)
        })
        for (let item of fileList) {
          item.createDate = moment(new Date()).format('YYYY-MM-DD HH:mm:ss')
          item.createBy = {
            id: '',
            name: ''
          }
          item.createBy.id = this.$store.state.user.id
          item.createBy.name = this.$store.state.user.name
          this.dataListNew.push(item)
        }
        for await (let item of this.dataListNew) {
          if (item.raw !== undefined && item.raw !== null && item.raw !== {}) {
            item.url = item.raw.url
            if (item.raw.url !== undefined && item.raw.url !== null && item.raw.url !== {}) {
              await this.ossService.getTemporaryUrl(item.raw.url).then((data) => {
                item.lsUrl = data.data
              })
            }
          }
        }
        this.tableKey = Math.random()
      },
      showFile (row) {
        openWindowOnUrl(row)
      },
      onPreview (url) {
        this.url = url
        this.showViewer = true
      },
      // 关闭查看器
      closeViewer () {
        this.url = ''
        this.showViewer = false
      },
      toHref (row) {
        toHref(row)
      },
      deleteById (row, index) {
        this.dataListNew.splice(index, 1)
        if (row.id !== null && row.id !== '' && row.id !== undefined) {
          this.dataList.splice(index, 1)
          // this.ossService.deleteMsgById(row.id)
        } else {
          let num
          if (this.dataList.length > 0) {
            num = this.dataList.length - 1
          } else {
            num = 0
          }
          this.$refs.upload.uploadFiles.splice(index - num, 1)
        }
      },
      /**
       * 关闭dialog时使用  清除el-upload中上传的文件
       */
      clearUpload () {
        this.$refs.upload.uploadFiles = []
        this.dataList = []
        this.dataListNew = []
      },
      /**
       * 获取当前文件列表中的文件数据
       */
      getDataList () {
        return this.dataListNew
      },
      /**
       * 判断进度条是否结束
       * @returns {boolean}
       */
      checkProgress () {
        if (this.progressFlag === true) {
          this.$message.warning('请等待文件上传完成再进行提交')
          return true
        }
        return false
      },
      ifName (row) {
        let suffix = row.name.substring(row.name.lastIndexOf('.') + 1)
        if (suffix === 'jpg' || suffix === 'png' || suffix === 'gif' || suffix === 'bmp' || suffix === 'jpeg') {
          return true
        } else {
          return false
        }
      }
    }
  }
</script>
